import pokereval
from hand_ev import HAND_EV

pe = pokereval.PokerEval()
deck = [ j + i for j in "AKQJT98765432" for i in "cshd" ]

hand_ev = { }
for k in HAND_EV:
    hand_ev[k] = HAND_EV[k][1]

def strength_potential(pocket, board, ignore=[]):

    cdef float ww, wt, wl, tw, tt, tl, lw, lt, ll
    cdef int i, j, winval, winval1, val, val1
    
    evaln = pe.evaln

    # Results.
    ww = 0.001
    wt = 0.001
    wl = 0.001
    tw = 0.001
    tt = 0.001
    tl = 0.001
    lw = 0.001
    lt = 0.001
    ll = 0.001 

    cards = deck[:]
    for c in pocket:
        cards.remove(c)
    for c in board:
        cards.remove(c)
    for c in ignore:
        cards.remove(c)
        
    hand = board[:]
    hand1 = board[:]

    # Score all possible opponent hands.

    op_evaln = { }
    
    for i in range(0, len(cards)):
        c1 = cards[i]
        hand.append(c1)

        for j in range(i + 1, len(cards)):
            c2 = cards[j]
            hand.append(c2)
            op_evaln[c1, c2] = evaln(hand)
            hand.pop()

        hand.pop()
               
    for extra in cards:

        cards1 = cards[:]

        cards1.remove(extra)
        hand1.append(extra)
        
        winval = evaln(pocket + hand)
        winval1 = evaln(pocket + hand1)
        
        for i in range(0, len(cards1)):

            c1 = cards1[i]
            hand1.append(c1)
            
            for j in range(i + 1, len(cards1)):

                c2 = cards1[j]

                c1c2 = (c1, c2)
                w = hand_ev[c1c2]

                hand1.append(c2)
                
                val = op_evaln[c1c2]
                val1 = evaln(hand1)
                
                if val < winval:

                    if val1 < winval1:
                        ww += w
                    elif val1 == winval1:
                        wt += w
                    else:
                        wl += w
                    
                elif val == winval:

                    if val1 < winval1:
                        tw += w
                    elif val1 == winval1:
                        tt += w
                    else:
                        tl += w

                else:

                    if val1 < winval1:
                        lw += w
                    elif val1 == winval1:
                        lt += w
                    else:
                        ll += w


                hand1.pop()
            hand1.pop()
        hand1.pop()

    win = ww + wt + wl
    tie = tw + tt + tl
    loss = lw + lt + ll

    ev = (win + tie / 2) / (loss + win + tie)
    ppot = (lw + lt / 2 + tw / 2) / (loss + tie / 2)
    npot = (wl + wt / 2 + tl / 2) / (win + tie / 2)
    

    return ev, ppot, npot
